///home/berryj/link/bin/genMethods "-g" "-t" "char*" "-h" "Collection" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Collection.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Collection.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef char* _char_;
typedef Collection<char* > _Collection_char__;

#define _Collection_char__DATA(x) ((Collection<char* >*) (EXTDATA(x)))
#define _Collection_char__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<char* > >::type))
#define _Collection_char__ISNT_DATA(x) (!_Collection_char__IS_DATA(x))

#define _Collection_char__CXX_DATA(x) (*(Collection<char* >*) (EXTDATA(VAL(x))))
#define _Collection_char__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<char* > >::type))
#define _Collection_char__CXX_ISNT_DATA(x) (!_Collection_char__CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_char__()
{
	Wrapper<_Collection_char__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_char__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_char_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_char_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_char_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_char__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_char__Methods(void);

PRIMITIVE STk_init_methods__Collection_char__()
{
	STk_add_new_cpp_primitive("collection-char?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::collectionP);
	STk_add_new_cpp_primitive("mset-char1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::buildMSet);
	STk_add_new_cpp_primitive("set-char1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::buildSet);
	STk_add_new_cpp_primitive("sequence-char1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::buildSequence);
	STk_add_new_cpp_primitive("Collection-char-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-char->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-char->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-char--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-char-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::collection2STkList);
	STk_add_new_cpp_primitive("set-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::collection2STkList);
	STk_add_new_cpp_primitive("mset-char->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::collection2STkString);
	STk_add_new_cpp_primitive("set-char->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-char->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_char_>::collection2STkString);

	addListMethod("mset-char",
		"mset-char1", LINK_NEW);
	addListMethod("set-char",
		"set-char1", LINK_NEW);
	addListMethod("sequence-char",
		"sequence-char1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_char__ >::name, 
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_char_ >::name, 
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_char__ >::name, 
		"<integer>",
		"Collection-char-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_char_ >::name, 
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_char_ >::name, 
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_char_ >::name, 
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_char__ >::name, 
		"Collection-char--", LINK_OVL);
	genExtra_Collection_char__Methods();
	return UNDEFINED;
}
